Assignee: John Abbott % Done: 100%

Category: EmacsUI Estimated time: 0.66 hour

Target version: CoCoA-5.3.0 Spent time: 0.65 hour

Description

Emacs becomes very slow when there are long lines in the output.

Consier adding a "fold"-like facility which breaks long lines into shorter ones (possibily inserting a given string just before the inserted

newline?)

Related issues:

Related to CoCoA-5 - Slug #875: Interpreter is too slow reading a big polynomial In Progress 03 May 2016

Related to CoCoA-5 - Slug #1363: Emacs UI: slow with long lines In Progress 13 Nov 2019

Related to CoCoA-5 - Feature #1431: Juxtaposition of string literals Rejected 03 Mar 2020

History

#1 - 28 Sep 2015 23:49 - John Abbott

I am thinking of the Unix command "fold".

This output option would certainly be useful when running CoCoA inside Emacs, and it may be helpful in other cases...?

There should be the possibility of not folding (e.g. setting the width to 0?)

#2 - 06 Jun 2016 23:51 - John Abbott

- Related to Slug #875: Interpreter is too slow reading a big polynomial added

#3 - 02 Mar 2020 22:05 - John Abbott

- Status changed from New to Resolved

- Assignee set to John Abbott

- Target version changed from CoCoA-5.?.? to CoCoA-5.3.0

- % Done changed from 0 to 50

There is now a fold function for strings which simply inserts a newline every N characters (it does not (currently) check if there are newlines already in

the string).

#4 - 03 Mar 2020 22:24 - John Abbott

- Related to Slug #1363: Emacs UI: slow with long lines added

#5 - 04 Mar 2020 15:33 - John Abbott

- Related to Feature #1431: Juxtaposition of string literals added

#6 - 04 Mar 2020 15:41 - John Abbott

- Status changed from Resolved to Closed

- % Done changed from 50 to 100
- Estimated time set to 0.66 h

The current impl fits the KISS philosophy.  Since I expect the main use to be fold(sprint(value), width), it is not important to check for newlines

inside the string.

If at some later stage it happens that people need fold to work "nicely" with strings containing newlines then we can revisit the defn and impl.

The current impl is simple, quick and easy to describe (and probably does what it wanted in practically every case).

Closing.

NOTE  I do wonder whether it might make sense to have a FoldSprint function, or even just extend fold so that it accepts any type arg1 and uses

sprint to make it into a string... again KISS suggests waiting to see how people use fold.
